# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2021"
name = "agave-scheduling-utils"
version = "4.0.0-rc.0"
authors = ["Anza Maintainers <maintainers@anza.xyz>"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Common utilities for building Agave scheduler implementations"
homepage = "https://anza.xyz/"
documentation = "https://docs.rs/agave-scheduling-utils"
readme = false
license = "Apache-2.0"
repository = "https://github.com/anza-xyz/agave"

[features]
agave-unstable-api = []

[lib]
name = "agave_scheduling_utils"
path = "src/lib.rs"

[dependencies.agave-scheduler-bindings]
version = "=4.0.0-rc.0"
features = ["agave-unstable-api"]

[dependencies.ahash]
version = "0.8.12"

[dependencies.solana-pubkey]
version = "4.1.0"
default-features = false

[dependencies.solana-transaction-error]
version = "3.0.0"

[dev-dependencies.tempfile]
version = "3.24.0"

[target."cfg(unix)".dependencies.agave-transaction-view]
version = "=4.0.0-rc.0"
features = ["agave-unstable-api"]

[target."cfg(unix)".dependencies.libc]
version = "0.2.180"

[target."cfg(unix)".dependencies.nix]
version = "0.31.1"
features = [
    "socket",
    "uio",
]

[target."cfg(unix)".dependencies.rts-alloc]
version = "2.0.0"

[target."cfg(unix)".dependencies.shaq]
version = "1.0.2"

[target."cfg(unix)".dependencies.thiserror]
version = "2.0.18"

[target."cfg(unix)".dev-dependencies.agave-scheduler-bindings]
version = "=4.0.0-rc.0"
features = ["agave-unstable-api"]

[lints.clippy]
arithmetic_side_effects = "deny"
default_trait_access = "deny"
manual_let_else = "deny"
used_underscore_binding = "deny"

[lints.rust]
boxed_slice_into_iter = "deny"
dependency_on_unit_never_type_fallback = "deny"
deprecated_safe_2024 = "deny"
impl_trait_overcaptures = "deny"
missing_unsafe_on_extern = "deny"
never_type_fallback_flowing_into_unsafe = "deny"
rust_2024_guarded_string_incompatible_syntax = "deny"
rust_2024_incompatible_pat = "deny"
rust_2024_prelude_collisions = "deny"
static_mut_refs = "deny"
unsafe_attr_outside_unsafe = "deny"
unsafe_op_in_unsafe_fn = "deny"

[lints.rust.unexpected_cfgs]
level = "warn"
priority = 0
check-cfg = [
    'cfg(target_os, values("solana"))',
    'cfg(feature, values("frozen-abi", "no-entrypoint"))',
    'cfg(target_arch, values("sbf"))',
]
